#ifndef BisqBitBuf_h
#define BisqBitBuf_h

#include <vector>
#include <string>

#include "sizes.h"

class BitBuf
{
	static const unsigned bbmin = 3, bbbits = 4;
	static const unsigned oomin = 2, oobits = 2;
	static const unsigned ppmin = 5, ppbits = 1;
public:
	BitBuf() : alloced(0), bitcount(0) { }
	BitBuf(const string &s) : alloced(0), bitcount(0) { *this = s; }
	
	void Resize(unsigned newbitsize);
	void Clear();
	
	void Add(unsigned value, unsigned count);
	void Copy(BitBuf &src, unsigned srcbitpos, unsigned count);

	BitBuf &Compress();
	BitBuf &Decompress();
	
	BitBuf &operator= (const string &s);
	
	operator std::string() const;
	
private:
	unsigned alloced;
	std::vector<BYTE> ptr;

	DWORD bitcount;
};

#endif
